## mingw-w64-ixion-0.20.0-1.src.tar.zst

=== src/CMakeLists.txt ===

add_subdirectory(libixion)
add_subdirectory(python)
add_subdirectory(test)

add_executable(ixion-parser
    ixion_parser.cpp
    app_common.cpp
    model_parser.cpp
    session_handler.cpp
    table_handler.cpp
)

add_executable(ixion-sorter
    app_common.cpp
    ixion_sorter.cpp
    sort_input_parser.cpp
)

add_executable(ixion-formula-tokenizer
    ixion_formula_tokenizer.cpp
)

target_link_libraries(ixion-parser ${Boost_LIBRARIES} ixion-${IXION_API_VERSION})
target_link_libraries(ixion-sorter ${Boost_LIBRARIES} ixion-${IXION_API_VERSION})
target_link_libraries(ixion-formula-tokenizer ${Boost_LIBRARIES} ixion-${IXION_API_VERSION})

# tests

# Copy the binaries necessary for running the parser tests below.
add_custom_command(TARGET ixion-parser POST_BUILD
    COMMAND ${CMAKE_COMMAND} -E copy_if_different
    $<TARGET_FILE:ixion-${IXION_API_VERSION}> $<TARGET_FILE:ixion-parser>
    ${CMAKE_CURRENT_BINARY_DIR}
)

file(GLOB PARSER_TEST_FILES ${PROJECT_SOURCE_DIR}/test/*.txt)

add_dependencies(check ixion-parser)

# Register tests for all test files and all thread counts (0-8).
foreach(_I RANGE 8)
    foreach(_TESTFILE ${PARSER_TEST_FILES})
        get_filename_component(_TFNAME ${_TESTFILE} NAME_WE)
        add_test(parser-test-t${_I}-${_TFNAME} ${CMAKE_CURRENT_BINARY_DIR}/ixion-parser -t ${_I} ${_TESTFILE})
    endforeach()
endforeach()

install(TARGETS ixion-parser ixion-sorter ixion-formula-tokenizer
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

=== src/libixion/CMakeLists.txt ===

add_library(ixion-${IXION_API_VERSION} SHARED
    address.cpp
    address_iterator.cpp
    calc_status.cpp
    cell.cpp
    cell_access.cpp
    cell_queue_manager.cpp
    compute_engine.cpp
    config.cpp
    debug.cpp
    dirty_cell_tracker.cpp
    document.cpp
    exceptions.cpp
    formula.cpp
    formula_calc.cpp
    formula_functions.cpp
    formula_function_opcode.cpp
    formula_interpreter.cpp
    formula_lexer.cpp
    formula_name_resolver.cpp
    formula_opcode.cpp
    formula_parser.cpp
    formula_result.cpp
    formula_tokens.cpp
    formula_value_stack.cpp
    global.cpp
    impl_types.cpp
    info.cpp
    interface.cpp
    lexer_tokens.cpp
    matrix.cpp
    model_context.cpp
    model_context_impl.cpp
    model_iterator.cpp
    model_types.cpp
    module.cpp
    named_expressions_iterator.cpp
    queue_entry.cpp
    table.cpp
    types.cpp
    utf8.cpp
    utils.cpp
    sheet_store.cpp
)

if(BUILD_VULKAN)

    add_library(ixion-${IXION_API_VERSION}-vulkan MODULE
        compute_engine_vulkan.cpp
        vulkan_obj.cpp
    )

    target_link_libraries(ixion-${IXION_API_VERSION}-vulkan
        ixion-${IXION_API_VERSION}
        Vulkan::Vulkan
    )

    install(TARGETS ixion-${IXION_API_VERSION}-vulkan
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    )

endif()

configure_file(constants.inl.in ${CMAKE_CURRENT_BINARY_DIR}/inl/constants.inl)

include_directories(${CMAKE_CURRENT_BINARY_DIR}/inl)

target_compile_definitions(ixion-${IXION_API_VERSION} PRIVATE IXION_BUILD DLL_EXPORT)

if(MSVC)
    target_compile_definitions(ixion-${IXION_API_VERSION} PRIVATE _USE_MATH_DEFINES)
endif()

install(TARGETS ixion-${IXION_API_VERSION}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

# test programs

add_executable(document-test EXCLUDE_FROM_ALL
    document_test.cpp
)

add_executable(general-test EXCLUDE_FROM_ALL
    general_test.cpp
)

add_executable(name-resolver-test EXCLUDE_FROM_ALL
    name_resolver_test.cpp
)

add_executable(ixion-test-track-deps EXCLUDE_FROM_ALL
    ixion_test_track_deps.cpp
)

add_executable(dirty-cell-tracker-test EXCLUDE_FROM_ALL
    dirty_cell_tracker_test.cpp
)

add_executable(compute-engine-test EXCLUDE_FROM_ALL
    compute_engine_test.cpp
)

target_include_directories(compute-engine-test PRIVATE ${PROJECT_SOURCE_DIR}/src/include)

target_link_libraries(document-test ixion-${IXION_API_VERSION} ixion-test)
target_link_libraries(general-test ixion-${IXION_API_VERSION} ixion-test)
target_link_libraries(ixion-test-track-deps ixion-${IXION_API_VERSION} ixion-test)
target_link_libraries(dirty-cell-tracker-test ixion-${IXION_API_VERSION} ixion-test)
target_link_libraries(compute-engine-test ixion-${IXION_API_VERSION} ixion-test)
target_link_libraries(name-resolver-test ixion-${IXION_API_VERSION} ixion-test)

add_dependencies(check
    document-test
    general-test
    ixion-test-track-deps
    dirty-cell-tracker-test
    compute-engine-test
    name-resolver-test
)

add_test(document-test document-test)
add_test(general-test general-test)
add_test(ixion-test-track-deps ixion-test-track-deps)
add_test(dirty-cell-tracker-test dirty-cell-tracker-test)
add_test(compute-engine-test compute-engine-test)
add_test(name-resolver-test name-resolver-test)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=ixion
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=0.20.0
pkgrel=1
pkgdesc="A general purpose formula parser & interpreter. (mingw-w64)"
arch=('any')
mingw_arch=('ucrt64' 'clang64' 'clangarm64')
url='https://gitlab.com/ixion/ixion'
msys2_references=(
  'archlinux: libixion'
)
license=('spdx:MPL-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-boost-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-autotools"
             "${MINGW_PACKAGE_PREFIX}-boost"
             "${MINGW_PACKAGE_PREFIX}-mdds"
             "${MINGW_PACKAGE_PREFIX}-python"
             "${MINGW_PACKAGE_PREFIX}-vulkan-loader"
             "${MINGW_PACKAGE_PREFIX}-vulkan-headers")
optdepends=("${MINGW_PACKAGE_PREFIX}-python: Python bindings"
            "${MINGW_PACKAGE_PREFIX}-vulkan-loader: Vulkan compute engine")
source=("https://gitlab.com/ixion/ixion/-/archive/${pkgver}/${_realname}-${pkgver}.tar.bz2"
        "001-fix-build-on-mingw.patch"
        "002-do-not-search-for-boost-system.patch")
sha256sums=('39e54cd486fed458c2a6e83a5e658d4c2e818862355b33645bb1342449428463'
            'f5554b215c7be10f48a2567824acf54a7b97831b4e4723d76edd4fede31931fd'
            '0bef56f5fe568a3131d187c95d7efec62e8617f23e02c3c20b6642da1e195837')

prepare() {
  cd ${_realname}-${pkgver}
  patch -p1 -i "${srcdir}"/001-fix-build-on-mingw.patch
  patch -p1 -i "${srcdir}"/002-do-not-search-for-boost-system.patch

  autoreconf -fiv
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  ../${_realname}-${pkgver}/configure \
    --prefix=${MINGW_PREFIX} \
    --enable-vulkan

  make
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"

  make check || true
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" make install

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys;sys.stdout.write('.'.join(map(str, sys.version_info[:2])))")
  # Use *.pyd extension for python module
  mv "${pkgdir}${MINGW_PREFIX}"/lib/python${_pyver}/site-packages/ixion.{dll,pyd}
  # remove unused import library
  rm -f "${pkgdir}${MINGW_PREFIX}"/lib/python${_pyver}/site-packages/ixion.dll.a

  install -Dm644 "${srcdir}"/${_realname}-${pkgver}/LICENSE \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
